﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Tobii.EyeTracking;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class Flasher : MonoBehaviour
{
    public static int currentIQ = 50;
    public static float gameTimer = 60;
    public GameObject[] toFlash;
    public int[] toFlashPoints; // add remove from IQ
    public float[] stareTime; // Time required to activate object
    public AudioClip[] goodClips;
    public AudioClip[] badClips;
    public bool gameOver = false;
    public GameObject phone;
    public Text IQText;
    public Text TimerText;
    int selected = 0;
    bool isOpen = false;
    void OnEnable()
    {
        TimerText = GameObject.Find("Timer").GetComponent<Text>();
        //SumScore.Add(10.0f);
        selected = Random.Range(0, toFlash.Length);
     //   Invoke("phoneRotate", 3f);
    //    Invoke("tvZoom", 3f);
    }

    void Update()
    {
        if (TimerText != null) //Fake Static
        {
            gameTimer -= Time.deltaTime;
            TimerText.text = gameTimer.ToString();
            if (gameTimer < 0 || currentIQ <= 0)
                SceneManager.LoadScene("final screen");
        }
    }



    public void Open()
    {
        isOpen = !isOpen;
        AnimationZoom(isOpen);
    }
    public void Close()
    {
        AnimationZoom(false);
    }
    private void KillScreen()
    {
        toFlash[selected].SetActive(false);
    }

    GameObject currentTask = null;
    float startedLooking;
    public void AnimationZoom(bool zoom)
    {
        if (zoom) // Zoomed inf
        {
            currentTask = Instantiate<GameObject>(toFlash[selected], transform);
            startedLooking = Time.realtimeSinceStartup;
        }
        else // Zooming Out
        {
            selected = Random.Range(0, toFlash.Length);
            float timeSpan = Time.realtimeSinceStartup - startedLooking;
            if (timeSpan > stareTime[selected])
            {
                // Update IQ
                if (toFlashPoints[selected] < 0)
                {
                    // GHET Stoopid
                    currentIQ += toFlashPoints[selected];
                    IQText.text = "IQ: " + currentIQ.ToString();
                    // Play good sound
                    AudioSource audio = GetComponent<AudioSource>();
                    AudioClip clip = goodClips[Random.Range(0, goodClips.Length)];
                    audio.PlayOneShot(clip);
                }
                else
                {
                    // GHET Smarterer
                    currentIQ += toFlashPoints[selected];
                    IQText.text = currentIQ.ToString();
                    // Play bad sound
                    AudioSource audio = GetComponent<AudioSource>();
                    AudioClip clip = badClips[Random.Range(0, badClips.Length)];
                    audio.PlayOneShot(clip);
                }
            }
            Destroy(currentTask);
        }
        GetComponent<Animator>().SetBool("zoomedin", zoom);
    }
}
