﻿using System.Collections;
using System.Collections.Generic;
using Tobii.EyeTracking;
using UnityEngine;
using UnityEngine.UI;

public class TrackingV2 : MonoBehaviour
{
    public GameObject toMove;
    public Camera mainCamera;
    public Text debugText;
    bool isMouse = true;
    // Use this for initialization
    void Start () {
       /* if (EyeTrackingHost.TobiiEngineAvailability == EngineAvailability.Running)
        {
            if (EyeTrackingHost.GetInstance().EngineVersion == null)
                isMouse = true;
        }
        else*/
         //   isMouse = true;
    }

    bool mouseDown = false;
	// Update is called once per frame
	void Update ()  
    {
        GameObject other = null;
        if (!isMouse)
        {
            GazePoint gP = EyeTracking.GetGazePoint();
            if (gP.IsValid)
            {
                Vector2 boom = mainCamera.ViewportToWorldPoint(gP.Viewport);
                //Vector2 world = mainCamera.ViewportToWorldPoint(gP.Viewport);
                // mainCamera.ViewportToWorldPoint
                //  float x = (boom.x - 1) * 6;
                // float y = boom.y * 2f;
                //Vector2 boom2 = gP.Screen
                // Debug.Log(world + " " + gP.Viewport);

                toMove.transform.position = boom;
                debugText.text = boom.ToString();
            }
            else
            {

            }
            other = EyeTracking.GetFocusedObject();
        }
        else
        {
            if (Input.GetMouseButtonDown(0) == true && mouseDown == false)
            {
                Ray mouseLine = mainCamera.ScreenPointToRay(Input.mousePosition);
                Vector2 mousePos = mainCamera.ScreenToWorldPoint(Input.mousePosition);
                transform.position = mousePos;
                mouseLine.origin.Set(mouseLine.origin.x, mouseLine.origin.y, -10);
                RaycastHit hit;
                if (Physics.Raycast(mouseLine, out hit))
                {
                    other = hit.transform.gameObject;
                }
            }
                mouseDown = Input.GetMouseButtonDown(0);
        }
        if (other != null)
        {
            Debug.Log("Found Object");
            other.GetComponent<Flasher>().Open();
        }
        if (!isMouse)
        {
            Flasher[] flashers = FindObjectsOfType<Flasher>();
            foreach (Flasher f in flashers)
            {
                if (other == null || other.name != f.name)
                f.Close();
            }
        }

    }
}
