﻿using System.Collections;
using System.Collections.Generic;
using Tobii.EyeTracking;
using UnityEngine;
using UnityEngine.UI;

public class trackingV1 : MonoBehaviour {

    public GameObject toMove;
    public Camera mainCamera;
    public Text debugText;
    private float surfaceOffset = 2736;

    IEyeTrackingHost _host;

    private IDataProvider<GazePoint> _gazePointProvider;
    private ITimestamped _lastHandledPoint;

    // Use this for initialization
    void Start () {
        debugText.text = "Debug Text";
        _host = EyeTrackingHost.GetInstance();
        if (!_host.IsInitialized)
            _host.Initialize();
        _gazePointProvider = _host.GetGazePointDataProvider();
    }

    private void OnEnable()
    {
        _gazePointProvider.Start(gameObject.GetInstanceID());
    }

    private void OnDisable()
    {
        // Request to stop the provider for this unique token
        _gazePointProvider.Stop(gameObject.GetInstanceID());
    }

    // Update is called once per frame
    void Update ()
    {
        Vector2 display = _host.DisplaySize.Value;
        Rect screenBounds = _host.ScreenBounds.Value;

        /* _host.G
         //if (EyeTracking.GetGazeTrackingStatus().Status == GazeTrackingStatus.GazeTracked)
         GazePoint gP = EyeTracking.GetGazePoint();
         if (gP.IsValid)
         {
             Vector2 boom = gP.Screen;
             boom.x = boom.x - surfaceOffset;
             //Vector2 world = mainCamera.ViewportToWorldPoint(gP.Viewport);
            // mainCamera.ViewportToWorldPoint
            //  float x = (boom.x - 1) * 6;
            // float y = boom.y * 2f;
             //Vector2 boom2 = gP.Screen
            // Debug.Log(world + " " + gP.Viewport);

             toMove.transform.position = gP.Screen;
             debugText.text = boom.ToString();
         }*/

        // Handle single gaze point:
        GazePoint last = _gazePointProvider.Last; // the last data point received from the eye tracker
        GazePoint frameConsistent = _gazePointProvider.GetFrameConsistentDataPoint(); // same as EyeTracking.GetGazePoint()
        // ...

        // Or handle all gaze points from the eye tracker:
        IEnumerable<GazePoint> pointsSinceLastHandled = _gazePointProvider.GetDataPointsSince(_lastHandledPoint);
        foreach (GazePoint point in pointsSinceLastHandled)
        {
            // handle each point that has arrived since previous Update()
            // ...
            if (point.IsValid)
                toMove.transform.position = point.Viewport;
            _lastHandledPoint = point;
        }
        
    }
}
