﻿using UnityEngine;
using Tobii.EyeTracking;

/// <summary>
/// Enable a set of UI elements if there is no gaze detected
/// </summary>
/// <remarks>
/// Referenced by the No Gaze Tracked visualization in the Eye Tracking Data example scene.
/// </remarks>
public class ShowNoGazeDetection : MonoBehaviour
{
    public GameObject Icon;
    public GameObject Text;

    private void Start()
    {
        
    }

    void Update()
    {
        switch (EyeTracking.GetGazeTrackingStatus().Status)
        {
            case GazeTrackingStatus.GazeTracked: // no gaze point data is streaming, inform the user why nothing is happening
                                                    //ShowGraphic(true);
                GetComponent<Camera>().backgroundColor = Color.green;
                break;
            default:
                // ShowGraphic(false);
                GetComponent<Camera>().backgroundColor = Color.red;
                break;
        }
    }

    private void ShowGraphic(bool isVisible)
    {
        Icon.SetActive(isVisible);
        Text.SetActive(isVisible);
    }
}
